{=======================================================================================================================

  Comming Library.

    .

========================================================================================================================

  :

  22.02.2016 [+] MenuItemsAddObject.
             [+] MenuItemsToString, MenuItemsFromString.
  21.02.2016 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982016 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingMenu.pas,v 1.2 2017/08/26 08:41:49 tsk Exp $
=======================================================================================================================}
unit CommingMenu;

interface

uses  Windows, SysUtils, Menus;

  function  MenuItemsToString( Menu: TPopupMenu ): String;
  procedure MenuItemsFromString( Reg: String; var Blank: TMenuItem );
  procedure MenuItemsAddObject( Text: String; ID: Integer; var Menu: TMenu; Blank: TMenuItem );

implementation
//======================================================================================================================
function MenuItemsToString( Menu: TPopupMenu ): String;
  var i: Integer;
begin
  Result := EmptyStr;
  for i:= 0 to Menu.Items.Count - 1 do Result := Result + Menu.Items[i].Caption + ''
                                                        + IntToStr( Menu.Items[i].Tag ) + '|';
end;
//======================================================================================================================
procedure MenuItemsFromString( Reg: String; var Blank: TMenuItem );
  var ln: String;
      mn: TMenu; new: TMenuItem;
      p, i, s: Integer;
begin
  mn := Blank.GetParentMenu;
  for i := mn.Items.Count - 1 downto 0 do mn.Items.Delete( i );
  p := Pos( '|', Reg );
  while p > 0 do begin
    ln := Copy( Reg, 1, p - 1 );
    i := Pos( '', ln );
    s := StrToInt( Copy( ln, i + 1, MaxInt ));
    if s > 0 then begin
      new := TMenuItem.Create( mn );
      new.Caption := Copy( ln, 1, i - 1 );
      new.ImageIndex := Blank.ImageIndex;
      new.Tag := s;
      new.OnClick := Blank.OnClick;
      mn.Items.Add( new );
    end;
    Reg := Copy( Reg, p + 1, MaxInt );
    p := Pos( '|', Reg );
  end;
end;
//======================================================================================================================
procedure MenuItemsAddObject( Text: String; ID: Integer; var Menu: TMenu; Blank: TMenuItem );
  var im: TMenuItem;
begin
  im := Menu.Items.Find( Text );
  if im = nil then begin
    im := TMenuItem.Create( Menu );
    im.Caption := Text;
    im.ImageIndex := Blank.ImageIndex;
    im.Tag := ID;
    im.OnClick :=  Blank.OnClick;
    Menu.Items.Insert( 0, im );
  end else im.MenuIndex := 0;
  while Menu.Items.Count > Menu.Tag do Menu.Items.Delete( Menu.Items.Count - 1 );
end;
//======================================================================================================================
end.
